diff --git a/src/director/doveadm-connection.c b/src/director/doveadm-connection.c
index 2d32c2081..708da9286 100644
--- a/src/director/doveadm-connection.c
+++ b/src/director/doveadm-connection.c
@@ -1067,7 +1070,10 @@ static void doveadm_connection_input(struct doveadm_connection *conn)
 
 static void doveadm_connection_set_io(struct doveadm_connection *conn)
 {
-	conn->io = io_add(conn->fd, IO_READ, doveadm_connection_input, conn);
+	if (conn->io == NULL) {
+		conn->io = io_add(conn->fd, IO_READ,
+				  doveadm_connection_input, conn);
+	}
 }
 
 struct doveadm_connection *
